package Stack
is
  type IntStackT is private;
  EmptyIntStack : constant IntStackT;

  function Empty(S: IntStackT) return Boolean;

  procedure Clear(S: out IntStackT);
  --# derives S from ;

  procedure Pop(S: in out IntStackT; X : out Integer);
  --# derives S from *
  --# &       X from S;

  procedure Push(S: in out IntStackT; X : in Integer);
  --# derives S from *,X;

private
   StackSize : constant Integer := 100;

   subtype PointerT is Natural range Natural'First .. StackSize;

   type IntVectorT is array (Integer range <>) of Integer;
   subtype StackIndexRange is Positive range 1 .. StackSize;
   subtype IntStackSupportT is IntVectorT (StackIndexRange);

   type IntStackT is record
      Pointer : PointerT;
      Vector : IntStackSupportT;
   end record;
   EmptyIntStack : constant IntStackT :=
     		IntStackT'(Pointer => 0,
                           Vector => IntStackSupportT'(StackIndexRange => 0));

end Stack;
